/* ----------------------------------------------------------------------------
 *  Serial Communication Lib Test
 * ----------------------------------------------------------------------------
 *  prog: max.rheiner@zhdk.ch / Zhdk / Interaction Design
 *  date: 11/16/2011
 * ----------------------------------------------------------------------------
 */
  
import processing.serial.*;

final static byte CMD_WRITE_DOUT2  = 1;
final static byte CMD_READ_DIN3    = 2;
final static byte CMD_READ_AD0     = 3;
final static byte CMD_RET_READ_DIN3= 4;
final static byte CMD_RET_READ_AD0 = 5;

SerialComLib  serialComLib;

void setup()
{
  size(500,400);
  
  println("Serial Ports:");
  println(Serial.list());
  
  String portName = Serial.list()[0];
  
  serialComLib = new SerialComLib(this, portName, 9600);
}
 
void draw()
{
  background(255); 
  
  serialComLib.update();
}

void keyPressed()
{
  switch(key)
  {
  case '1':
    println("Send read DIN3");
    serialComLib.beginSend(CMD_READ_DIN3);
    serialComLib.endSend();  
    break;
  case '2':
    println("Send read AD0");
    serialComLib.beginSend(CMD_READ_AD0);
    serialComLib.endSend();  
    break;
  case '3':
    println("Send write DOUT2 low");
    serialComLib.beginSend(CMD_WRITE_DOUT2);
      serialComLib.sendByte(0);
    serialComLib.endSend();  
    break;
  case '4':
    println("Send write DOUT2 high");
    serialComLib.beginSend(CMD_WRITE_DOUT2);
      serialComLib.sendByte(1);
    serialComLib.endSend();  
    break;
  }
}

void onReceiveSerialCom(int cmdId,SerialComLib serialCom)
{  
  switch(cmdId)
  {
  case CMD_RET_READ_DIN3:
    println("DIN3: " + serialCom.getByte());
    // get din3
    break;
  case CMD_RET_READ_AD0:
    // get ad0
    println("AD0: " + serialCom.getUShort());
    break;
  default:
    println("Unknown command: " + cmdId);
    break;
  }
}
